unit fMainTS;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants, System.StrUtils,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.WebBrowser,
  FMX.StdCtrls, FMX.ScrollBox, FMX.Memo, FMX.Controls.Presentation, FMX.Edit;

type
  TfrmMain = class(TForm)
{$REGION 'Components'}
    wbTS: TWebBrowser;
    edtURL: TEdit;
    gbURL: TGroupBox;
    btnNavigate: TButton;
    gbBulkRelate: TGroupBox;
    mmoList: TMemo;
    btnRelate: TButton;
    pbFeedback: TProgressBar;
    cbRelateUnrelate: TCheckBox;
{$ENDREGION}
    procedure btnNavigateClick(Sender: TObject);
    procedure btnRelateClick(Sender: TObject);
    procedure cbRelateUnrelateClick(Sender: TObject);
    procedure wbTSDidFinishLoad(ASender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.fmx}

procedure TfrmMain.btnNavigateClick(Sender: TObject);
var
  iPos: Integer;
begin
  wbTS.Navigate(edtURL.Text);
  iPos        := Pos('/', edtURL.Text, 9);
  if iPos = 0 then
  begin
    edtURL.Text := edtURL.Text + '/';
  end
  else
  begin
    edtURL.Text := Copy(edtURL.Text, 1, iPos);
  end;
end;

procedure TfrmMain.btnRelateClick(Sender: TObject);
var
  iLoop, iMax: Integer;
  sRow       : string;
  aIDs       : TArray<string>;
begin
  iMax             := Pred(mmoList.Lines.Count);
  pbFeedback.Value := 0;
  pbFeedback.Max   := mmoList.Lines.Count;
  for iLoop := 0 to iMax do
  begin
    sRow := mmoList.Lines[iLoop];
    aIDs := sRow.Split([';', ',', #9, ' ']);
    if Length(aIDs) = 2 then
    begin
      wbTS.EvaluateJavaScript(
        Format('$.ajax({url : "%s/term/object/%srelateObject.spg?termKey=%s&objectKey=%s"});',
               [edtURL.Text, IfThen(not cbRelateUnrelate.IsChecked, 'un'), aIDs[0], aIDs[1]]
        )
      );
    end;
    pbFeedback.Value := pbFeedback.Value + 1;
  end;
end;

procedure TfrmMain.cbRelateUnrelateClick(Sender: TObject);
begin
  btnRelate.Text := IfThen(cbRelateUnrelate.IsChecked, 'Unr', 'R') + 'elate';
end;

procedure TfrmMain.wbTSDidFinishLoad(ASender: TObject);
begin
  btnRelate.Enabled := True;
end;

end.
